"""Raw representations of every data type in the AWS ECR service.

See Also:
    `AWS developer guide for ECR
    <https://docs.aws.amazon.com/AmazonECR/latest/userguide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = [
    "Repository",
    "RepositoryProperties",
]


@attrs(**ATTRSCONFIG)
class RepositoryProperties(ResourceProperties):
    LifecyclePolicy = attrib(default=None)
    RepositoryName = attrib(default=None)
    RepositoryPolicyText = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Repository(Resource):
    """A Repository for ECR.

    See Also:
        `AWS Cloud Formation documentation for Repository
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ecr-repository.html>`_
    """

    RESOURCE_TYPE = "AWS::ECR::Repository"

    Properties: RepositoryProperties = attrib(
        factory=RepositoryProperties,
        converter=create_object_converter(RepositoryProperties),
    )
